#!/bin/bash

# Description: 指定した期間の、指定した曜日の稼働日を、休日を考慮して算出する
# select_days.bashとholidays.bashを本スクリプトと同じディレクトリに配置すること

usage_exit() {
    echo "$0 [-m] [-w 'week days'] yyyymmdd yyyymmdd"
    echo "  week days: Su Mo Tu We Th Fr Sa"
    echo "    $0 -m -w 'Tu|Th|Fr' 20210805 20220204"
    exit 1
}

ourholiday=""
w='Su|Mo|Tu|We|Th|Fr|Sa'
while getopts :mw: OPT ; do
  case $OPT in
    m) ourholiday="-m" ;;
    w) w=${OPTARG} ;;
  esac
done
shift $((OPTIND - 1))

if [ $# -lt 2 ]; then
    usage_exit
fi

comm -23 <(${0%/*}/select_days.bash -w "$w" $1 $2) <(${0%/*}/holidays.bash $ourholiday $1 $2)
