#!/bin/bash

# Description: 指定した期間の、指定した曜日の日を抽出する
# USAGE: $0 -w 'Tu|Th|Fr' 20210805 20220204

LANG=C
LC_TIME=C

usage_exit() {
    echo $0 -w "$0 -w 'Tu|Th|Fr' 20210805 20220204"
    echo "  week days: Su Mo Tu We Th Fr Sa"
    exit 1
}

w='Su|Mo|Tu|We|Th|Fr|Sa'
while getopts :w: OPT ; do
  case $OPT in
    w) w=${OPTARG} ;;
  esac
done
shift $((OPTIND - 1))

if [ $# -lt 2 ]; then
    usage_exit
fi

declare -i by bm bd ey em ed y m
by=$(expr 0 + ${1:0:4}) || exit
bm=$(expr 0 + ${1:4:2}) || exit
bd=$(expr 0 + ${1:6:2}) || exit

ey=$(expr 0 + ${2:0:4}) || exit
em=$(expr 0 + ${2:4:2}) || exit
ed=$(expr 0 + ${2:6:2}) || exit

listup () {
    local y=$by
    local m=$bm
    while [ $y -le $ey ]; do
        while [ $m -le 12 ]; do
            ncal $m $y | egrep "^($w)" | egrep -o '[0-9]+' |
            while read d ; do printf "%4d%0.2d%0.2d\n" $y $m $d ; done
            [ $y -eq $ey -a $m -eq $em ] && break
            let m++
        done
        let y++
        m=1
    done
}

listup | sort |
while read l; do
    [ $l -lt $((by*10000 + bm*100 + bd)) ] && continue
    if [ $l -le $((ey*10000 + em*100 + ed)) ]; then
        echo $l
    else
        break
    fi
done
